{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Полезные ссылки #"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Python – язык с огромной экосистемой. Чтобы помочь вам в этой экосистеме ориентироваться, в этом документе я постараюсь дать некоторые полезные советы и ссылки для начинающих программировать на Python.\n",
    "\n",
    "Начнем с основной ссылки – документации Python 3. Документация Python чрезвычайно подробна и наполнена большим количеством примеров – ее часто ставят в пример другим языкам (https://docs.python.org/3/).\n",
    "\n",
    "Если вы знаете язык программирования C, то в любой непонятной ситуации вы всегда можете заглянуть в исходный код CPython, который доступен на Github (https://github.com/python/cpython).\n",
    "\n",
    "Красивый код – это одна из мантр языка Python. Все Python-программисты стараются следовать советам по стилю кода, описанным в документе PEP 8 (https://www.python.org/dev/peps/pep-0008/).\n",
    "\n",
    "Есть утилита autopep8, которая позволяет автоматически приводить код к виду, соответствующему PEP 8 (https://pypi.python.org/pypi/autopep8).\n",
    "\n",
    "Библиотеки, написанные сообществом, находятся на ресурсе PyPI (Python Package Index) (https://pypi.python.org/pypi).\n",
    "\n",
    "Именно с этого ресурса будут устанавливаться внешние пакеты, когда вы будете устанавливать их с помощью утилиты pip. Лучший способ найти библиотеку для решения той или иной задачи – постараться загуглить ее – часто поиск Google выдает наиболее релевантный вариант. На GitHub есть коллекция хороших библиотек для решения всевозможных задач (https://github.com/vinta/awesome-python).\n",
    "\n",
    "Большая база вопросов и ответов по Python сосредоточена на ресурсе Stack Overflow (https://stackoverflow.com/) – вы будете часто натыкаться на него, когда будете искать решение в непонятных ситуациях.\n",
    "\n",
    "Большинство из материалов по ссылкам выше на английском языке. Однако и в русском сегменте интернета информации по Python достаточно. Обратите внимание, что многое из того, что вы найдете может относиться к Python второй версии – обращайте на это внимание, мы с вами изучаем Python 3. Хорошие ресурсы для новичков в Python на русском языке:\n",
    "\n",
    "https://pythonworld.ru/samouchitel-python\n",
    "\n",
    "https://metanit.com/python/tutorial/\n",
    "\n",
    "Также есть русскоязычная версия портала stackoverflow, где есть множество вопросов/ответов с тегом \"python\" (https://ru.stackoverflow.com/questions/tagged/python).\n",
    "\n",
    "Таблица cоответствия консольных команд Windows и Linux (https://white55.ru/cmd-sh.html).\n",
    "\n",
    "Не забывайте и про книги - их про Python очень много, в том числе и на русском языке. Опять же, обращайте внимание на версию языка, которая в них описана.\n",
    "\n",
    "Тем, кто любит книги, советуем обратить внимание на следующие издания:\n",
    "\n",
    "- Марк Саммерфилд - Программирование на Python 3. Подробное руководство\n",
    "- Марк Лутц - Изучаем Python, 5-е издание\n",
    "\n",
    "Эти книги, особенно вторая, могут показаться тяжелыми для чтения, так как являются очень подробными справочниками по языку Python. Однако в них собраны практически все сведения о языке."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.10.12"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
